"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.flat-map");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.join");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.unscopables.flat-map");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.regexp.constructor");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.match");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _global = _interopRequireDefault(require("global"));

var _ansiColors = require("ansi-colors");

var _register = _interopRequireDefault(require("babel-plugin-require-context-hook/register"));

var _plur = _interopRequireDefault(require("plur"));

var _reactElementToJsxString = _interopRequireDefault(require("react-element-to-jsx-string"));

var _server = require("@storybook/core/server");

var framework = _interopRequireWildcard(require("@storybook/react"));

var _utils = require("./utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

(0, _register["default"])();
var storybook = framework;

var isFile = function isFile(file) {
  try {
    return _fs["default"].lstatSync(file).isFile();
  } catch (err) {
    return false;
  }
};

var extensions = ['ts', 'tsx', 'js', 'jsx'];

var resolveFile = function resolveFile(configDir, filenames) {
  return filenames.flatMap(function (filename) {
    return extensions.map(function (ext) {
      return _path["default"].join(configDir, "".concat(filename, ".").concat(ext));
    });
  }).find(isFile) || false;
};

var getPreviewFile = function getPreviewFile(configDir) {
  return resolveFile(configDir, ['preview', 'config']);
};

var getMainFile = function getMainFile(configDir) {
  return resolveFile(configDir, ['main']);
};

var getConfigPathParts = function getConfigPathParts(input) {
  var configDir = _path["default"].resolve(input);

  if (_fs["default"].lstatSync(configDir).isDirectory()) {
    var output = {};
    var preview = getPreviewFile(configDir);
    var main = getMainFile(configDir);

    if (preview) {
      output.preview = preview;
    }

    if (main) {
      var _require = require(main),
          _require$stories = _require.stories,
          stories = _require$stories === void 0 ? [] : _require$stories;

      output.stories = stories.map(function (pattern) {
        var _toRequireContext = (0, _server.toRequireContext)(pattern),
            basePath = _toRequireContext.path,
            recursive = _toRequireContext.recursive,
            match = _toRequireContext.match;

        var regex = new RegExp(match);
        return _global["default"].__requireContext(configDir, basePath, recursive, regex);
      });
    }

    return output;
  }

  return {
    preview: configDir
  };
};

var configure = function configure(options) {
  var configDir = options.configDir;

  var _getConfigPathParts = getConfigPathParts(configDir),
      preview = _getConfigPathParts.preview,
      stories = _getConfigPathParts.stories;

  if (preview) {
    var _require2 = require(preview),
        parameters = _require2.parameters,
        decorators = _require2.decorators,
        globals = _require2.globals,
        globalTypes = _require2.globalTypes,
        argTypesEnhancers = _require2.argTypesEnhancers;

    if (decorators) {
      decorators.forEach(function (decorator) {
        return storybook.addDecorator(decorator);
      });
    }

    if (parameters || globals || globalTypes) {
      storybook.addParameters(_objectSpread(_objectSpread({}, parameters), {}, {
        globals: globals,
        globalTypes: globalTypes
      }));
    }

    if (argTypesEnhancers) {
      argTypesEnhancers.forEach(function (enhancer) {
        return storybook.addArgTypesEnhancer(enhancer);
      });
    }
  }

  if ((stories === null || stories === void 0 ? void 0 : stories.length) > 0) {
    storybook.configure(stories, false, false);
  }
};

var _default = function _default(configDir, _ref) {
  var outFile = _ref.outFile;
  configure({
    configDir: configDir
  });
  var snippets = storybook.raw().map(function (_ref2) {
    var group = _ref2.kind,
        name = _ref2.name,
        getOriginal = _ref2.getOriginal,
        _ref2$parameters = _ref2.parameters;
    _ref2$parameters = _ref2$parameters === void 0 ? {} : _ref2$parameters;
    var playroom = _ref2$parameters.playroom;

    var _getOptions = (0, _utils.getOptions)(playroom),
        disable = _getOptions.disable,
        reactElementToJSXStringOptions = _getOptions.reactElementToJSXStringOptions;

    if (disable) {
      return undefined;
    }

    console.log("Generating ".concat((0, _ansiColors.yellow)([group, name].join('/')), " snippet..."));
    var storyFn = getOriginal();
    var element = (0, _utils.isStoryFnWithArgs)(storyFn) ? storyFn(storyFn.args) : storyFn();
    var code = (0, _reactElementToJsxString["default"])(element, reactElementToJSXStringOptions);
    return {
      group: group,
      name: name,
      code: code
    };
  }).filter(Boolean);

  _fs["default"].writeFileSync(_path["default"].resolve(process.cwd(), outFile), JSON.stringify(snippets, null, 2));

  console.log("\n".concat(snippets.length, " ").concat((0, _plur["default"])('snippet', snippets.length), " generated."));
};

exports["default"] = _default;